/*
 * ACB-BF592 UARTGR[obNR[h(|[O) gccp
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * Last Update: 2012/07/27
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 * EclipsefobOsꍇAgdbݒ
 * uEclipse & Blackfin Toolchain(gcc)CXg[E`[gAv
 * ɋLڂĂ郊Zbg̐ݒsĂB
 * http://kaneko-sys.co.jp/support/
 *
 */

#include <cdefBF592-A.h>
#include <builtins.h>
#include <string.h>
#include <stdint.h>

/* VXeNbN(100MHz) */
#define SCLOCK_HZ		(100000000)
/* {[[g(115200bps) */
#define UART0_BAUDRATE	(115200)
/* UART0_DLL/UART0_DLH̐ݒl */
#define UART0_DIVISOR	(SCLOCK_HZ/16/UART0_BAUDRATE)

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

static void s_uart_init(void)
{
	/* UARTCl[u */
	*pUART0_GCTL = 1;

	/* UART̐ݒ */
	*pUART0_LCR |= DLAB;
	*pUART0_DLL = UART0_DIVISOR & 0xFF;
	*pUART0_DLH = UART0_DIVISOR >> 8;
	*pUART0_LCR &= ~DLAB;

	/* UART[hݒ peB 8bit 1Xgbvrbg */
	*pUART0_LCR = WLS(8);

	/* UART݋֎~ */
	*pUART0_IER = 0;

	/* PF11/PF12sUARTɊU */
    *pPORTF_MUX &= ~(PF11 | PF12);	/* PF11,PF120ɂ */
    *pPORTF_FER |= PF11 | PF12;		/* PF11,PF12UART0ɊU */
}

static void s_uart_putc(char ch)
{
	/* UART0 LSRTHRE1ɂȂ܂ő҂B1ȂΑMWX^ */
	while(0 == (*pUART0_LSR & THRE)) ssync();
	*pUART0_THR = ch;	/* ꕶM */
	ssync();
}

static void s_uart_print(const char *p_buf)
{
	int l_lc;
	int l_len = strlen(p_buf);
	
	for(l_lc = 0; l_lc < l_len; l_lc++)
	{
		s_uart_putc(p_buf[l_lc]);	/* ꕶM */
	}
}

static char s_uart_getc(void)
{
	/* UART0_LSRDR1ɂȂ܂ő҂B1ȂΎMWX^Ƀf[^ */
	while(0 == (*pUART0_LSR & DR)) ssync();
	return *pUART0_RBR;
}

int main(void)
{
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);

	s_uart_init();
    s_uart_print("Echo back sample.\r\n");
    while(1)
    {
    	s_uart_putc(s_uart_getc());
    }
}
